﻿using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TagCloudGenerator
{
    public partial class Form1 : Form
    {
        //initialize data storing arrays
        string[] wordArray = new string[100]; 
        int[] cntArray = new int[100];
        int[] cntArrayOrig = new int[100];

        //to keep record of drawn rectangles
        RectangleF[] recArray = new RectangleF[100];

        int scale = 20;

        int cntsum = 0;
        int cnt = 0;
        int reccnt = 0;

        Random rnd = new Random();

        float totalArea;
        Size screenSize;
        float recArea = 0;

        bool enlarged = false;

        Graphics formGraphics;

        public Form1()
        {
            InitializeComponent();

            screenSize = Screen.AllScreens.Select(screen => screen.Bounds).Aggregate(Rectangle.Union).Size;
            totalArea = screenSize.Width * screenSize.Height;

            formGraphics = this.CreateGraphics();

            //read data into arrays
            try
            {
                using (StreamReader sr = new StreamReader("test.txt"))
                {
                    string line;
 
                    while ((line = sr.ReadLine()) != null)
                    {
                        string[] splitted = line.Split(' ');
                        wordArray[cnt] = splitted[0];
                        //MessageBox.Show(wordArray[cnt]);
                        cntArrayOrig[cnt] = Int32.Parse(splitted[1]);
                        cnt++;
                    }
                   // MessageBox.Show(cnt.ToString());
                }
            }
            catch (Exception e)
            {
                MessageBox.Show("Can't open file: " + "\r\n" + e.Message, Application.ProductName);
            }

            processData(wordArray, cntArray);
        }

        //changed for my purposes, but based on microsoft example code
        public bool DrawString(string theString, int cntValue)
        {
            Font drawFont = new System.Drawing.Font("Comic Sans", cntValue); //size should be set according to data
            SolidBrush drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Black);
            StringFormat drawFormat = new System.Drawing.StringFormat();

            //randomize x,y
            int x, y;

            x = rnd.Next(screenSize.Width);
            y = rnd.Next(screenSize.Height);

            //generate appropriate rectangle
            SizeF param = formGraphics.MeasureString(theString, drawFont);
            Size lw = Size.Round(param);
            Point n = new Point(x, y);

            RectangleF drawRec = new RectangleF(n, param);

            //add rectangleF to array and check for interesection
            bool ndone = true;
            bool bad;
            int badcnt = 0;

            while (ndone)
            {
                bad = false;

                if(badcnt == 20) //return a false once unable to fit a certain rectangle 20 times
                {
                    //MessageBox.Show("maybe too big");
                    return false;
                }

                //this is for the first word when reccnt is still 0
                if(drawRec.X + drawRec.Width >= screenSize.Width || drawRec.Y + drawRec.Height >= screenSize.Height)
                {
                    bad = true;
                }

                for (int i = 0; i < reccnt; i++)
                {
                    if (drawRec.IntersectsWith(recArray[i]) || (drawRec.X + drawRec.Width >= screenSize.Width) || drawRec.Y + drawRec.Height >= screenSize.Height) //if an intersection is found, or out of bounds
                    {
                        bad = true;
                        badcnt++;
                        break;
                    }
                }
                if (bad) //if it fails to find good coordinates for say, 10 times?, it should adjust to have a smaller scale and redraw everything
                {
                    x = rnd.Next(screenSize.Width);
                    y = rnd.Next(screenSize.Height); 
                    n = new Point(x, y);

                    drawRec = new RectangleF(n, param);
                    bad = false;
                }
                else
                {
                    ndone = false;

                    //update total rectangle area
                    recArea = recArea + (drawRec.Width * drawRec.Height);

                    recArray[reccnt] = drawRec; //record into array
                    reccnt++;
                }
            }

            formGraphics.DrawString(theString, drawFont, drawBrush, drawRec, drawFormat); //draw the string!

            drawFont.Dispose();
            drawBrush.Dispose();

            return true;
        }

        private void processData(string[] wordArray, int[] cntArray) //using default scale
        {
            for(int i = 0; i < cnt; i++)
            {
                //make sure font size isn't zero
                if ((cntArrayOrig[i] / scale) == 0)
                {
                    cntArray[i] = 1;
                }
                else
                {
                    cntArray[i] = cntArrayOrig[i] / scale; //adjust...or implement a converting system to get appropriate sizes
                }

                //MessageBox.Show(cntArray[i].ToString());

                cntsum = cntsum + cntArray[i];
            }
        }

        private void btMinimize_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Minimized;
        }

        private void btExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        //WORK IN PROGRESS
        private void btGenerate_Click(object sender, EventArgs e)
        {
            generateTags();
        }

        private bool generateTags()
        {
            for (int i = 0; i < cnt; i++)
            {
                if (!DrawString(wordArray[i], cntArray[i])) //if ever unable to generate with certain scale
                {
                    formGraphics.Clear(Color.White);

                    recArray = new RectangleF[100]; //reset the rectangle array
                    reccnt = 0;

                    scale = scale + 1;
                    //MessageBox.Show("scale inc to " + scale.ToString());
                    enlarged = true;

                    processData(wordArray, cntArray); //reprocess data
                    //MessageBox.Show("scale set to " + scale.ToString());

                    //redraw everything with adjusted scale
                    if (generateTags())
                    {
                        break; //if successful, break
                    }
                }
            }
            //return true;

            if(enlarged) //this means it had to reduce string sizes
            {
                return true;
            }
            else //potential to use more space, so decrease scale and reprocess/redraw
            {
                formGraphics.Clear(Color.White);
                recArray = new RectangleF[100]; //reset the rectangle array
                reccnt = 0;

                if (scale > 1)
                    scale = scale - 1;
                else
                {
                    MessageBox.Show("scale minimum reached");
                    return true;
                }

                //MessageBox.Show("scale dec to " + scale.ToString());
                processData(wordArray, cntArray); //reprocess data
                generateTags();

                return true;
            }
        }
    }
}
